/*
 * sudo version 1.2
 * Copyright (C) 2008  wantora
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <windows.h>
#include <shlwapi.h>
#include <stdio.h>
#include "sudo_server.h"
#include "sudo_client.h"
#include "utils.h"

#define SERVER_MODE  0
#define CLIENT_MODE  1

void server(const char *argv[], int i, char debug_mode) {
	char *command = shiftArgs(GetCommandLine(), i);
	
	serverMain((const char*)argv[0], command, debug_mode);
}

void client(const char *argv[], int i) {
	char *command = shiftArgs(GetCommandLine(), i+1);
	
	clientMain((const char*)argv[i], command);
}

int main(int argc, char *argv[]) {
	int i;
	char mode = SERVER_MODE;
	char debug_mode = 0;
	
	for (i = 1; i < argc; i++) {
		if (strcmp(argv[i], "--client") == 0) {
			mode = CLIENT_MODE;
		} else if (strcmp(argv[i], "--debug") == 0) {
			debug_mode = 1;
		} else {
			break;
		}
	}
	
	if (i >= argc) exit(1);
	
	switch (mode) {
	case SERVER_MODE:
		server((const char**)argv, i, debug_mode);
		break;
	case CLIENT_MODE:
		client((const char**)argv, i);
		break;
	}
	
	return 0;
}
