/*
 * sudo_client.c
 */

#include <windows.h>
#include <shlwapi.h>
#include <wincon.h>
#include "sudo_client.h"
#include "utils.h"

static char isEndProcess;

/* OtpCv̑M */
static DWORD WINAPI pipeWriter(LPVOID lpArg) {
	HANDLE *handles = (HANDLE *)lpArg;
	HANDLE hRead = handles[0];
	HANDLE hFile = handles[1];
	char szOut[1024];
	DWORD dwRead;
	DWORD dwWritten;
	DWORD dwAvail;
	
	while (1) {
		if (!PeekNamedPipe(hRead, NULL, 0, NULL, &dwAvail, NULL)) break;
		
		if (isEndProcess && dwAvail == 0) break;
		
		while (dwAvail > 0) {
			if (!ReadFile(hRead, szOut, sizeof(szOut) - 1, &dwRead, NULL)) return 0;
			if (dwRead > 0) WriteFile(hFile, szOut, dwRead, &dwWritten, NULL);
			
			if (!PeekNamedPipe(hRead, NULL, 0, NULL, &dwAvail, NULL)) return 0;
		}
		
		Sleep(0);
	}
	
	return 0;
}

/* eCtrl+Cm */
static DWORD WINAPI exitThread(LPVOID lpArg) {
	HANDLE hCEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, (char *)lpArg);
	
	while (1) {
		WaitForSingleObject(hCEvent, INFINITE);
		GenerateConsoleCtrlEvent(CTRL_C_EVENT, 0);
	}
	
	return 0;
}

/* CTRL_C_EVENT𖳌 */
static BOOL WINAPI HandlerRoutine(DWORD dwCtrlType) {
	if (dwCtrlType == CTRL_C_EVENT) {
		return TRUE;
	}
	
	return FALSE;
}

static void set_envpath(const char *env) {
	for (; *env; env++) {
		if (strnicmp(env, "PATH=", 5) == 0) {
			env += 5;
			SetEnvironmentVariable("PATH", env);
		}
		while (*env) {
			env++;
		}
	}
}

static void clientStart(const char *pipeName, HANDLE hRead, HANDLE hProcess) {
	HANDLE threadArgs[2];
	HANDLE hFile;
	HANDLE hThread;
	
	/*OtpCv*/
	WaitNamedPipe(getPipeName(pipeName), NMPWAIT_WAIT_FOREVER);
	hFile = CreateFile(getPipeName(pipeName), GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE) return;
	
	/*XbhN*/
	threadArgs[0] = hRead;
	threadArgs[1] = hFile;
	isEndProcess = FALSE;
	
	hThread = CreateThread(NULL, 0, pipeWriter, (LPVOID)threadArgs, 0, NULL);
	if (hThread == NULL) return;
	
	/*ҋ@*/
	WaitForSingleObject(hProcess, INFINITE);
	isEndProcess = TRUE;
	WaitForSingleObject(hThread, INFINITE);
	
	CloseHandle(hThread);
	CloseHandle(hFile);
}

/* M */
void clientMain(const char *pipeName, char *command) {
	HANDLE hRead, hWrite;
	HANDLE hExitThread;
	HANDLE hEnvFile;
	char *env;
	
	SECURITY_ATTRIBUTES sa = {0};
	STARTUPINFO si = {0};
	PROCESS_INFORMATION pi = {0};
	
	/*ȅIm*/
	hExitThread = CreateThread(NULL, 0, exitThread, (LPVOID)getCEventName(pipeName), 0, NULL);
	if (hExitThread == NULL) return;
	
	SetConsoleCtrlHandler(HandlerRoutine, TRUE);
	
	/*ϐ̎擾*/
	WaitNamedPipe(getEnvPipeName(pipeName), NMPWAIT_WAIT_FOREVER);
	hEnvFile = CreateFile(getEnvPipeName(pipeName), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hEnvFile == INVALID_HANDLE_VALUE) return;
	
	{
		DWORD dwRead;
		DWORD dwAvail = 0;
		
		while (dwAvail == 0) {
			PeekNamedPipe(hEnvFile, NULL, 0, NULL, &dwAvail, NULL);
			Sleep(0);
		}
		
		env = (char*)malloc(sizeof(char) * dwAvail);
		if (env == NULL) return;
		
		ReadFile(hEnvFile, env, sizeof(char) * dwAvail, &dwRead, NULL);
	}
	
	set_envpath(env);
	CloseHandle(hEnvFile);
	
	/*pCv쐬*/
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.lpSecurityDescriptor = NULL;
	sa.bInheritHandle = TRUE;
	if (!CreatePipe(&hRead, &hWrite, &sa, 0)) return;
	
	SetHandleInformation(hRead, HANDLE_FLAG_INHERIT, 0);
	
	/*CreateProcess*/
	si.cb = sizeof(STARTUPINFO);
	si.dwFlags = STARTF_USESTDHANDLES;
	si.hStdOutput = hWrite;
	si.hStdError = hWrite;
	
	if (CreateProcess(NULL, command, NULL, NULL, TRUE, 0, env, NULL, &si, &pi)) {
		CloseHandle(pi.hThread);
		clientStart(pipeName, hRead, pi.hProcess);
		CloseHandle(pi.hProcess);
	}
	
	free(env);
	CloseHandle(hExitThread);
	CloseHandle(hRead);
	CloseHandle(hWrite);
}
